#include "header.h"



/*------------------------------------------------------------------------------*/
/*           Fonction principale de dtection des erreurs de syntaxe            */
/*------------------------------------------------------------------------------*/

void syntaxe(int nbLignes, char ScNom[50], int typeSc, int obse) {

FILE *fScript, *fLog;
char c, cInt[7], ligne[5000];
int k, l, test, ligneType[5000], ok, ligneTraitee, check, var, varType, nomScript, varScn, declarations, varDcl, varOBSE, BlocBegin[5000], ligneBegin[5000], ligneEnd[5000], ligneEndif[5000], ligneEndwhile[5000];
ERREUR err;


fScript = fopen(ScNom, "rt");
if ( fScript == NULL ) {
   printf("Impossible d'ouvrir le fichier \"%s\" depuis le fichier source \"MainSyntaxe.cpp\"\n\n", ScNom);
   system("PAUSE");
   exit(1);
}

/* Dtection des blocs Begin/End */
strDetectTest(ligneBegin, nbLignes, ScNom, "begin");
strDetectTest(ligneEnd, nbLignes, ScNom, "end");
strDetectTest(ligneEndif, nbLignes, ScNom, "endif");
strDetectTest(ligneEndwhile, nbLignes, ScNom, "endwhile");
for ( k = 0; k < nbLignes; k++ ) {
    if ( ligneEnd[k] != 0 ) {
         if ( ligneEndif[k] != 0 ) ligneEnd[k] = 0;
         if ( ligneEndwhile[k] != 0 ) ligneEnd[k] = 0;
    }
}

var = 0;
for ( k = 0; k < nbLignes; k++ ) {
    BlocBegin[k] = var;
    if ( ligneBegin[k] == 1 ) {
         var = 1;
         BlocBegin[k] = 1;
    }
    else {
         if ( ( var == 1 ) && ( ligneEnd[k] == 1 ) ) var = 0;
    }
}

nomScript = 0;
varScn = 0;
declarations = 0;
varDcl = 0;

for ( k = 0; k < (nbLignes+1); k++ ) {
    ligneTraitee = 0;
    /*--------------------------------*/
    /* Acquisition de la k-ieme ligne */
    /*--------------------------------*/
    l = 0;
    check = 0;
    c = getc(fScript);
    while ( ( ( c != ';' ) || ( check%2 != 0 ) ) && ( c != '\n' ) && ( c != '\r') && ( c != EOF ) ) {
          ligne[l] = c;
          c = getc(fScript);
          if ( c == '"' ) check++;
          l++;
    }
    while ( l < 5000 ) {
          ligne[l] = '\0';
          l++;
    }
    while ( ( c != '\n' ) && ( c != '\r') && ( c != EOF ) ) c = getc(fScript);
    
    if ( ( ligne[0] == '\n' ) || ( ligne[0] == '\r' ) || ( ligne[0] == EOF ) ) ligneTraitee = 1;
    
    /*----------------------------------------------------------------------------------------*/
    /*                     Dtection des erreurs de syntaxe dans la ligne                     */
    /*----------------------------------------------------------------------------------------*/
        
    /* Recherche des cas o on ouvre un guillement sans le fermer (erreur 10) */
    test = 0;
    for ( l = 0; l < strlen(ligne); l++ ) {
        if ( ligne[l] == '"' ) {
             test = 1 - test;
        }
    }    
    if ( test == 1 ) {
         fLog = fopen("DbTempTES4", "ab");
         if ( fLog == NULL ) {
              printf("Impossible d'ouvrir le fichier temporaire \"DbTempTES4\" depuis le fichier source \"MainSyntaxe.cpp\"\n\n", ScNom);
              system("PAUSE");
              exit(1);
         }
         err.ligneErr = k;
         err.niveau = 2;
         strcpy(err.messageErr, "    - Ligne ");
         int2str(&(cInt[0]), k+1);
         strcat(err.messageErr, cInt);
         strcat(err.messageErr, " : un guillemet n'a pas t referm.");
         fwrite(&err, sizeof(ERREUR), 1, fLog);
         ligneTraitee = 1;
         fclose(fLog);
    }
    
    /* Recherche des cas o on ouvre une parenthses sans la fermer (erreur 11) et o on ne met pas d'espace avant ou aprs la parenthse (respectivement erreurs 12 et 13) */
    test = 0;
    for ( l = 0; l < strlen(ligne); l++ ) {
        if ( ligne[l] == '(' ) {
             /* if ( l > 0 ) {
                  if ( ligne[l-1] != ' ' ) {
                       fLog = fopen("DbTempTES4", "ab");
                       if ( fLog == NULL ) {
                            printf("Impossible d'ouvrir le fichier temporaire \"DbTempTES4\" depuis le fichier source \"MainSyntaxe.cpp\"\n\n", ScNom);
                            system("PAUSE");
                            exit(1);
                       }
                       err.ligneErr = k;
                       err.niveau = 1;
                       strcpy(err.messageErr, "    - Ligne ");
                       int2str(&(cInt[0]), k+1);
                       strcat(err.messageErr, cInt);
                       strcat(err.messageErr, " : une parenthse sans espace avant.");
                       fwrite(&err, sizeof(ERREUR), 1, fLog);
                       ligneTraitee = 1;
                       fclose(fLog);
                  }
             }
             var = strlen(ligne)-1;
             if ( l < var ) {
                  if ( isspace(ligne[l+1]) == 0 ) {
                       fLog = fopen("DbTempTES4", "ab");
                       if ( fLog == NULL ) {
                            printf("Impossible d'ouvrir le fichier temporaire \"DbTempTES4\" depuis le fichier source \"MainSyntaxe.cpp\"\n\n", ScNom);
                            system("PAUSE");
                            exit(1);
                       }
                       err.ligneErr = k;
                       err.niveau = 1;
                       strcpy(err.messageErr, "    - Ligne ");
                       int2str(&(cInt[0]), k+1);
                       strcat(err.messageErr, cInt);
                       strcat(err.messageErr, " : une parenthse sans espace aprs.");
                       fwrite(&err, sizeof(ERREUR), 1, fLog);
                       ligneTraitee = 1;
                       fclose(fLog);
                  }
             } */
             test++;
        }
        if ( ligne[l] == ')' ) {
             /* if ( l > 0 ) {
                  if ( ligne[l-1] != ' ' ) {
                       fLog = fopen("DbTempTES4", "ab");
                       if ( fLog == NULL ) {
                            printf("Impossible d'ouvrir le fichier temporaire \"DbTempTES4\" depuis le fichier source \"MainSyntaxe.cpp\"\n\n", ScNom);
                            system("PAUSE");
                            exit(1);
                       }
                       err.ligneErr = k;
                       err.niveau = 1;
                       strcpy(err.messageErr, "    - Ligne ");
                       int2str(&(cInt[0]), k+1);
                       strcat(err.messageErr, cInt);
                       strcat(err.messageErr, " : une parenthse sans espace avant.");
                       fwrite(&err, sizeof(ERREUR), 1, fLog);
                       ligneTraitee = 1;
                       fclose(fLog);
                  }
             }
             var = strlen(ligne)-1;
             if ( l < var ) {
                  if ( isspace(ligne[l+1]) == 0 ) {
                       fLog = fopen("DbTempTES4", "ab");
                       if ( fLog == NULL ) {
                            printf("Impossible d'ouvrir le fichier temporaire \"DbTempTES4\" depuis le fichier source \"MainSyntaxe.cpp\"\n\n", ScNom);
                            system("PAUSE");
                            exit(1);
                       }
                       err.ligneErr = k;
                       err.niveau = 1;
                       strcpy(err.messageErr, "    - Ligne ");
                       int2str(&(cInt[0]), k+1);
                       strcat(err.messageErr, cInt);
                       strcat(err.messageErr, " : une parenthse sans espace aprs.");
                       fwrite(&err, sizeof(ERREUR), 1, fLog);
                       ligneTraitee = 1;
                       fclose(fLog);
                  }
             } */
             test--;
        }
    }
    
    if ( test > 0 ) {
         fLog = fopen("DbTempTES4", "ab");
         if ( fLog == NULL ) {
              printf("Impossible d'ouvrir le fichier temporaire \"DbTempTES4\" depuis le fichier source \"MainSyntaxe.cpp\"\n\n", ScNom);
              system("PAUSE");
              exit(1);
         }
         err.ligneErr = k;
         err.niveau = 2;
         strcpy(err.messageErr, "    - Ligne ");
         int2str(&(cInt[0]), k+1);
         strcat(err.messageErr, cInt);
         strcat(err.messageErr, " : ");
         int2str(&(cInt[0]), test);
         strcat(err.messageErr, cInt);
         strcat(err.messageErr, " parenthse");
         if ( test > 1 ) strcat(err.messageErr, "s n'ont pas t refermes.");
         else strcat(err.messageErr, " n'a pas t referme.");
         fwrite(&err, sizeof(ERREUR), 1, fLog);
         ligneTraitee = 1;
         fclose(fLog);
    }
    
    if ( ligneTraitee == 0 ) {
         var = 0;
         for ( l = 0; l < strlen(ligne); l++ ) {
             if ( isspace(ligne[l]) == 0 ) var = 1;
         }
         if ( var == 0 ) ligneTraitee = 1;
    }
    
    
    synDetectBadTab(ligne, k);
   
    
/* Fonctions intervenant avant les blocs Begin/End */
    /* Nom du script */
    varScn = ligneTraitee;
    if ( ligneTraitee == 0 ) strFoncID("ScriptName", 99, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncID("Scn", 99, ligne, &ligneTraitee, k);
    if ( ( varScn == 0 ) && ( ligneTraitee == 1 ) && ( nomScript == 1 ) ) {
         fLog = fopen("DbTempTES4", "ab");
         if ( fLog == NULL ) {
              printf("Impossible d'ouvrir le fichier temporaire \"DbTempTES4\" depuis le fichier source \"MainSyntaxe.cpp\"\n\n", ScNom);
              system("PAUSE");
              exit(1);
         }
         err.ligneErr = k;
         err.niveau = 2;
         strcpy(err.messageErr, "    - Ligne ");
         int2str(&(cInt[0]), k+1);
         strcat(err.messageErr, cInt);
         strcat(err.messageErr, " : vous avez dclar plusieurs fois le nom du script !");
         fwrite(&err, sizeof(ERREUR), 1, fLog);
         ligneTraitee = 1;
         fclose(fLog);
    }
    if ( ( varScn == 0 ) && ( ligneTraitee == 1 ) && ( nomScript == 0 ) ) nomScript = 1;
    
    
    /* Dclaration des variables */
    varDcl = ligneTraitee;
    if ( ligneTraitee == 0 ) strFoncID("Short", 0, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncID("Float", 1, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncID("Long", 2, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncID("Ref", 3, ligne, &ligneTraitee, k);
    if ( ( varDcl == 0 ) && ( ligneTraitee == 1 ) && ( declarations != 0 ) ) {
         fLog = fopen("DbTempTES4", "ab");
         if ( fLog == NULL ) {
              printf("Impossible d'ouvrir le fichier temporaire \"DbTempTES4\" depuis le fichier source \"MainSyntaxe.cpp\"\n\n", ScNom);
              system("PAUSE");
              exit(1);
         }
         err.ligneErr = k;
         err.niveau = 2;
         strcpy(err.messageErr, "    - Ligne ");
         int2str(&(cInt[0]), k+1);
         strcat(err.messageErr, cInt);
         strcat(err.messageErr, " : vous avez dclar des variables aprs des lignes de code !");
         fwrite(&err, sizeof(ERREUR), 1, fLog);
         ligneTraitee = 1;
         fclose(fLog);
    }

    var = ligneTraitee;

/* Fonctions systme (ncessaires ou trs frquentes) */
    if ( ligneTraitee == 0 ) synDetectSetTo(ligne, &ligneTraitee, k, obse);
    if ( ligneTraitee == 0 ) synDetectBegin(ligne, &ligneTraitee, k, typeSc);
    if ( ligneTraitee == 0 ) synDetectTEST("If", ligne, &ligneTraitee, k, obse);
    if ( ligneTraitee == 0 ) synDetectTEST("ElseIf", ligne, &ligneTraitee, k, obse);
    if ( ligneTraitee == 0 ) synDetectTEST("While", ligne, &ligneTraitee, k, obse);
    if ( ligneTraitee == 0 ) strFonctionSeule("Else", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("Endif", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("EndWhile", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("End", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("Return", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) synDetectMessageBox("MessageBox", ligne, &ligneTraitee, k, obse);
    if ( ligneTraitee == 0 ) synDetectMessage(ligne, &ligneTraitee, k, obse);
    if ( ligneTraitee == 0 ) synDetectSetActorFullName(ligne,&ligneTraitee, k);
    if ( ligneTraitee == 0 ) synDetectSetCellFullName(ligne,&ligneTraitee, k);
    if ( ligneTraitee == 0 ) synDetectPlaceAtMe(ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) synDetectMoveToMarker(ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) synDetectMoveTo(ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) synDetectForceActorValue(ligne, &ligneTraitee, k, obse);
    if ( ligneTraitee == 0 ) synDetectForceAV(ligne, &ligneTraitee, k, obse);
    if ( ligneTraitee == 0 ) synDetectModPCMiscStat(ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) synDetectModPCMS(ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) synDetectLock(ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) synDetectSetLevel(ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) synDetectRemoveItem(ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) synDetectSayTo(ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) synDetectEssentialDeathReload(ligne, &ligneTraitee, k);
    
    varOBSE = ligneTraitee;
    if ( ligneTraitee == 0 ) strFoncValShort("DisableKey", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("DisableMouse", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncValShort("EnableKey", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("EnableMouse", ligne, &ligneTraitee, k);
    if ( ( varOBSE == 0 ) && ( ligneTraitee == 1 ) && ( obse == 0 ) ) {
         fLog = fopen("DbTempTES4", "ab");
         if ( fLog == NULL ) {
              printf("Impossible d'ouvrir le fichier temporaire \"DbTempTES4\" depuis le fichier source \"MainSyntaxe.cpp\"\n\n", ScNom);
              system("PAUSE");
              exit(1);
         }
         err.ligneErr = k;
         err.niveau = 2;
         strcpy(err.messageErr, "    - Ligne ");
         int2str(&(cInt[0]), k+1);
         strcat(err.messageErr, cInt);
         strcat(err.messageErr, " : le script utilise une fonction dpendant d'Oblivion Script Extender !");
         fwrite(&err, sizeof(ERREUR), 1, fLog);
         ligneTraitee = 1;
         fclose(fLog);
    }
    
    if ( ligneTraitee == 0 ) strFoncValShort("EnableFastTravel", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncValShort("EnableFast", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("EnablePlayerControls", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("EnableLinkedPathPoints", ligne, &ligneTraitee, k, 19);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("Enable", ligne, &ligneTraitee, k, 19);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("DisableLinkedPathPoints", ligne, &ligneTraitee, k, 19);
    if ( ligneTraitee == 0 ) strFonctionSeule("DisablePlayerControls", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("Disable", ligne, &ligneTraitee, k, 19);
    
    if ( ligneTraitee == 0 ) strFonctionSeule("AdvancePCLevel", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("AdvLevel", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("AutoSave", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("KillAllActors", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("KillAll", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("RefreshTopicList", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("ReleaseWeatherOverride", ligne, &ligneTraitee, k);    
    
    varType = ligneTraitee;
    if ( ligneTraitee == 0 ) strFonctionSeule("ScriptEffectElapsedSeconds", ligne, &ligneTraitee, k);
    if ( ( varType == 0 ) && ( ligneTraitee == 1 ) ) typeScriptWrite(3, k);
    
    if ( ligneTraitee == 0 ) strFonctionSeule("ShowBirthsignMenu", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("ShowClassMenu", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("ShowEnchantment", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("ShowRaceMenu", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("ShowSpellMaking", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("WakeUpPC", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("AddFlames", ligne, &ligneTraitee, k, 19);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("CreateFullActorCopy", ligne, &ligneTraitee, k, 19);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("DispelAllSpells", ligne, &ligneTraitee, k, 15);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("DropMe", ligne, &ligneTraitee, k, 11);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("ForceCloseOblivionGate", ligne, &ligneTraitee, k, 19);
    if ( ligneTraitee == 0 ) strFonc_optID_choiceApp("KillActor", 15, 15, 1, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("KillActor", ligne, &ligneTraitee, k, 15);
    if ( ligneTraitee == 0 ) strFonc_optID_choiceApp("Kill", 15, 15, 1, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("Kill", ligne, &ligneTraitee, k, 15);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("PickIdle", ligne, &ligneTraitee, k, 15);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("RemoveFlames", ligne, &ligneTraitee, k, 19);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("RemoveScriptPackage", ligne, &ligneTraitee, k, 15);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("Reset3DState", ligne, &ligneTraitee, k, 19);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("ResetFallDamageTimer", ligne, &ligneTraitee, k, 15);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("ResetHealth", ligne, &ligneTraitee, k, 15);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("SameFactionAsPC", ligne, &ligneTraitee, k, 15);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("SameRaceAsPC", ligne, &ligneTraitee, k, 15);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("SameSexAsPC", ligne, &ligneTraitee, k, 15);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("SetAtStart", ligne, &ligneTraitee, k, 19);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("SkipAnim", ligne, &ligneTraitee, k, 15);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("StopCombat", ligne, &ligneTraitee, k, 15);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("StopCombatAlarmOnActor", ligne, &ligneTraitee, k, 15);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("scaOnActor", ligne, &ligneTraitee, k, 15);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("StopLook", ligne, &ligneTraitee, k, 15);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("TrapUpdate", ligne, &ligneTraitee, k, 19);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("Yield", ligne, &ligneTraitee, k, 15);
    if ( ligneTraitee == 0 ) strFoncValShort("AddAchievement", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncValShort("ModAmountSoldStolen", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncValShort("ModPCFame", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncValShort("ModPCInfamy", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncValShort("SetInCharGen", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncValShort("SetPCFame", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncValShort("SetPCInfamy", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncValShort("SetPCSleepHours", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncValShort("SetShowQuestItems", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncValShort("ShowDialogueSubtitles", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncValShortApp("SetAlert", 15, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncValShortApp("SetDestroyed", 19, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncValShortApp("SetDoorDefaultOpen", 41, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncValShortApp("SetForceRun", 15, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncValShortApp("SetForceSneak", 15, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncValShortApp("SetGhost", 15, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncValShortApp("SetIgnoreFriendlyHits", 15, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncValShortApp("Sifh", 15, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncValShortApp("SetInvestmentGold", 15, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncValShortApp("SetItemValue", 19, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncValShortApp("SetNoRumors", 15, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncValShortApp("SetOpenState", 41, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncValShortApp("SetRestrained", 15, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncValShortApp("SetRigidBodyMass", 19, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncValShortApp("SetUnconscious", 15, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncValFloatApp("ModBarterGold", 15, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncValFloatApp("ModCrimeGold", 15, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncValFloatApp("ModScale", 19, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncValFloatApp("SetActorAlpha", 15, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncValFloatApp("Saa", 15, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncValFloatApp("SetActorRefraction", 15, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncValFloatApp("SetBarterGold", 15, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncValFloatApp("SetCrimeGold", 15, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncValFloatApp("SetPackDuration", 15, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncValFloatApp("SPDur", 15, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncValFloatApp("SetScale", 19, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncValFloatApp("SetSize", 19, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncID("CompleteQuest", 51, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncID("DuplicateAllItems", 19, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncID("PlaySound", 93, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncID("ResetInterior", 95, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncID("SelectPlayerSpell", 20, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncID("SpSpell", 20, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncID("SendTrespassAlarm", 15, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncID("StartQuest", 51, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncID("StopQuest", 51, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncID("StreamMusic", 92, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDApp("AddScriptPackage", 15, 62, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDApp("AddSpell", 15, 20, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDApp("AddTopic", 15, 50, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDApp("Dispell", 15, 21, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDApp("DuplicateNPCStats", 15, 15, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDApp("Look", 15, 19, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDApp("PlaySound3D", 19, 93, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDApp("PreloadMagicEffect", 15, 21, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDApp("RemoveSpell", 15, 20, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDApp("SameFaction", 15, 15, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDApp("SameRace", 15, 15, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDApp("SameSex", 15, 15, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDApp("SetClass", 15, 61, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDApp("SetCombatStyle", 15, 65, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDApp("SetCs", 15, 65, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDApp("StopMagicEffectVisuals", 15, 21, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDApp("sme", 15, 21, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDApp("StopMagicShaderVisuals", 15, 21, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDApp("sms", 15, 21, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDApp("StartCombat", 15, 15, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDApp("StopWaiting", 15, 62, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDApp("VampireFeed", 15, 15, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDApp("Wait", 15, 62, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDshort_choiceApp("AddItem", 10, 11, 1, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDshort_choiceApp("Drop", 15, 11, 1, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDshort_choiceApp("ModFactionRank", 15, 91, 1, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDshort_choiceApp("SetCellPublicFlag", 19, 95, 0, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDshort_choiceApp("SetEssential", 19, 15, 0, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDshort_choiceApp("SetFactionRank", 15, 91, 1, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDshort_choiceApp("SetPCExpelled", 19, 91, 0, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDshort_choiceApp("SetPCFactionAttack", 19, 91, 0, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDshort_choiceApp("SetPCFactionMurder", 19, 91, 0, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDshort_choiceApp("SetPCFactionSteal", 19, 91, 0, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDshort_choiceApp("SetPCFactionSubmitAuthority", 19, 91, 0, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDshort_choiceApp("SetPublic", 19, 95, 0, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDshort_choiceApp("SetQuestObject", 19, 51, 1, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDshort_choiceApp("SetStage", 19, 51, 0, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncID_optShort_choiceApp("ForceWeather", ligne, 19, 63, 0, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncID_optShort_choiceApp("Fw", ligne, 19, 63, 0, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncID_optShort_choiceApp("LoopGroup", ligne, 19, 94, 1, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncID_optShort_choiceApp("PlayBink", ligne, 19, 92, 0, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncID_optShort_choiceApp("PlayGroup", ligne, 19, 94, 1, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncID_optShort_choiceApp("Say", ligne, 15, 50, 1, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncID_optShort_choiceApp("SetWeather", ligne, 19, 63, 0, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncID_optShort_choiceApp("Sw", ligne, 19, 63, 0, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncID_optShort_choiceApp("ShowMap", ligne, 19, 95, 0, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncID_optShort_choiceApp("UnequipItem", ligne, 15, 11, 1, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncID_optShort_choiceApp("UnequipObject", ligne, 15, 11, 1, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncID_optShort_choiceApp("EquipItem", ligne, 15, 11, 1, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncID_optShort_choiceApp("EquipObject", ligne, 15, 11, 1, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncID_optFloat_choiceApp("PlayMagicEffectVisuals", ligne, 19, 21, 1, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncID_optFloat_choiceApp("pme", ligne, 19, 21, 1, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncID_optFloat_choiceApp("PlayMagicShaderVisuals", ligne, 19, 21, 1, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncID_optFloat_choiceApp("pms", ligne, 19, 21, 1, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDID_choiceApp("Cast", ligne, 19, 20, 19, 1, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDID_choiceApp("StartConversation", ligne, 15, 15, 51, 1, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncID_optID("SetCellOwnership", 95, 66, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonc_optID_choiceApp("RemoveMe", 19, 10, 1, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("RemoveMe", ligne, &ligneTraitee, k, 19);
    if ( ligneTraitee == 0 ) strFonc_optID_choiceApp("SetOwnership", 19, 66, 1, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("SetOwnership", ligne, &ligneTraitee, k, 19);
    if ( ligneTraitee == 0 ) strFonc_optID_choiceApp("EvaluatePackage", 15, 62, 1, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("EvaluatePackage", ligne, &ligneTraitee, k, 15);
    if ( ligneTraitee == 0 ) strFonc_optID_choiceApp("Evp", 15, 62, 1, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("Evp", ligne, &ligneTraitee, k, 15);
    if ( ligneTraitee == 0 ) strFoncAxeFloat("Rotate", 19, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncAxeFloat("SetAngle", 19, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncAxeFloat("SetPos", 19, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonc_optShort_choiceApp("CloseCurrentOblivionGate", ligne, 19, 0, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("CloseCurrentOblivionGate", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonc_optShort_choiceApp("CloseOblivionGate", ligne, 19, 1, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("CloseOblivionGate", ligne, &ligneTraitee, k, 19);
    if ( ligneTraitee == 0 ) strFoncStatShort_choiceApp("AdvancePCSkill", 15, 0, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncStatShort_choiceApp("AdvSkill", 15, 0, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncStatShort_choiceApp("ModActorValue", 15, 1, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncStatShort_choiceApp("ModAV", 15, 1, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncStatShort_choiceApp("ModPCAttribute", 15, 0, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncStatShort_choiceApp("ModPCA", 15, 0, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncStatShort_choiceApp("ModPCSkill", 15, 0, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncStatShort_choiceApp("ModPCS", 15, 0, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonc_optShort_choiceApp("ResurrectActor", ligne, 15, 1, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("ResurrectActor", ligne, &ligneTraitee, k, 15);
    if ( ligneTraitee == 0 ) strFonc_optShort_choiceApp("Resurrect", ligne, 15, 1, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("Resurrect", ligne, &ligneTraitee, k, 15);
    if ( ligneTraitee == 0 ) strFoncStatShort_choiceApp("SetActorValue", 15, 1, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncStatShort_choiceApp("SetAV", 15, 1, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonc_optShort_choiceApp("TriggerHitShader", ligne, 19, 0, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("TriggerHitShader", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonc_optShort_choiceApp("Ths", ligne, 19, 0, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("Ths", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonc_optShort_choiceApp("Unlock", ligne, 41, 1, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("Unlock", ligne, &ligneTraitee, k, 41);
    if ( ligneTraitee == 0 ) strFoncFloatFloatFloatIDApp("PositionCell", ligne, 19, 95, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncFloatFloatFloatIDApp("PosCell", ligne, 19, 95, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncFloatFloatFloatIDApp("PositionWorld", ligne, 19, 68, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncFloatFloatFloatIDApp("PosWorld", ligne, 19, 68, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonc_optID_optShort("Activate", 15, 19, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("Activate", ligne, &ligneTraitee, k, 19);
    if ( ligneTraitee == 0 ) strFonc_optID_optShort("RemoveAllItems", 10, 10, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("RemoveAllItems", ligne, &ligneTraitee, k, 10);
    if ( ligneTraitee == 0 ) strFonctionSeule("PayFineThief", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("PayFine", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("GoToJail", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDfloat("ForceTakeCover", 15, 15, ligne, &ligneTraitee, k, obse);
    if ( ligneTraitee == 0 ) strFoncIDfloat("TakeCover", 15, 15, ligne, &ligneTraitee, k, obse);
    if ( ligneTraitee == 0 ) strFoncIDfloat("ModDisposition", 15, 15, ligne, &ligneTraitee, k, obse);
    if ( ligneTraitee == 0 ) strFoncIDIDshort("ModFactionReaction", ligne, 91, 91, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDIDshort("SetFactionReaction", ligne, 91, 91, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonc_optID_optID("ForceFlee", 15, 95, 19, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("ForceFlee", ligne, &ligneTraitee, k, 15);
    if ( ligneTraitee == 0 ) strFonc_optID_optID("Flee", 15, 95, 19, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("Flee", ligne, &ligneTraitee, k, 15);


    
/* Non documentes */
    if ( ligneTraitee == 0 ) strFoncUndocumented("CSize", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncUndocumented("GetQuestVariable", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncUndocumented("GetPersuasionNumber", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncUndocumented("GetTotalPersuasionNumber", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncUndocumented("GetUsedItemActivate", ligne, &ligneTraitee, k);
    
/* Dpendantes d'Oblivion Script Extender */
    varOBSE = ligneTraitee;
    if ( ligneTraitee == 0 ) strFoncValShort("AHammerKey", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncValShort("HammerKey", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncValShort("HoldKey", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncStatShort_choiceApp("ModActorValue2", 15, 1, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncValShort("MoveMouseX", ligne, &ligneTraitee, k, 1);
    if ( ligneTraitee == 0 ) strFoncValShort("MoveMouseY", ligne, &ligneTraitee, k, 1);
    if ( ligneTraitee == 0 ) strFonctionSeule("PurgeCellBuffers", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("con_RefreshINI", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncValShort("ReleaseKey", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncValShort("con_RunMemoryPass", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncValShort("SetMouseSpeedX", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncValShort("SetMouseSpeedY", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncValShort("con_SetCameraFOV", ligne, &ligneTraitee, k, 1);
    if ( ligneTraitee == 0 ) strFoncValShort("con_SetClipDist", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncValFloat("con_SetGamma", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncValFloatApp("con_SetTargetRefraction", 15, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule_OptCall("con_SexChange", ligne, &ligneTraitee, k, 15);
    if ( ligneTraitee == 0 ) strFoncValShort("TapKey", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFonctionSeule("con_ToggleDetection", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncValShort("UnhammerKey", ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncFloatFloatFloatApp("con_HairTint", ligne, 15, &ligneTraitee, k, 1);
    if ( ligneTraitee == 0 ) strFoncFloatFloatFloatApp("con_WaterDeepColor", ligne, 19, &ligneTraitee, k, 0);
    if ( ligneTraitee == 0 ) strFoncFloatFloatFloatApp("con_WaterReflectionColor", ligne, 19, &ligneTraitee, k, 0);
    if ( ligneTraitee == 0 ) strFoncFloatFloatFloatApp("con_WaterShallowColor", ligne, 19, &ligneTraitee, k, 0);
    if ( ligneTraitee == 0 ) strFoncFloatFloatApp("con_SetFog", ligne, 19, &ligneTraitee, k, 0);
    if ( ligneTraitee == 0 ) strFoncFloatFloatApp("con_SetTargetRefractionFire", ligne, 15, &ligneTraitee, k, 1, 1);
    if ( ligneTraitee == 0 ) strFoncFloatX6App("con_SetHDRParam", ligne, 19, &ligneTraitee, k, 0);
    if ( ligneTraitee == 0 ) strFoncFloatX4App("con_SetImageSpaceGlow", ligne, 19, &ligneTraitee, k, 0);
    if ( ligneTraitee == 0 ) synDetectMessageBox("PrintToConsole", ligne, &ligneTraitee, k, obse);
    if ( ligneTraitee == 0 ) strFoncIDshort_choiceApp("con_SetGameSetting", 19, 80, 0, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDshort_choiceApp("SetNumericGameSetting", 19, 80, 0, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncIDshort_choiceApp("con_SetINISetting", 19, 81, 0, ligne, &ligneTraitee, k);
    if ( ligneTraitee == 0 ) strFoncTexte_optFloat_choiceApp("con_ModWaterShader", ligne, 19, 0, &ligneTraitee, k);
    
    if ( ligneTraitee == 0 ) strFoncUndocumented("con_SetSkyParam", ligne, &ligneTraitee, k);

    if ( ( varOBSE == 0 ) && ( ligneTraitee == 1 ) && ( obse == 0 ) ) {
         fLog = fopen("DbTempTES4", "ab");
         if ( fLog == NULL ) {
              printf("Impossible d'ouvrir le fichier temporaire \"DbTempTES4\" depuis le fichier source \"MainSyntaxe.cpp\"\n\n");
              system("PAUSE");
              exit(1);
         }
         err.ligneErr = k;
         err.niveau = 2;
         strcpy(err.messageErr, "    - Ligne ");
         int2str(&(cInt[0]), k+1);
         strcat(err.messageErr, cInt);
         strcat(err.messageErr, " : le script utilise une fonction dpendant d'Oblivion Script Extender !");
         fwrite(&err, sizeof(ERREUR), 1, fLog);
         ligneTraitee = 1;
         fclose(fLog);
    }


    if ( ( var == 0 ) && ( ligneTraitee == 1 ) ) declarations = 1;
    
    if ( ( var == 0 ) && ( ligneTraitee == 1 ) && ( nomScript == 0 ) ) {
         fLog = fopen("DbTempTES4", "ab");
         if ( fLog == NULL ) {
              printf("Impossible d'ouvrir le fichier temporaire \"DbTempTES4\" depuis le fichier source \"MainSyntaxe.cpp\"\n\n", ScNom);
              system("PAUSE");
              exit(1);
         }
         err.ligneErr = k;
         err.niveau = 2;
         strcpy(err.messageErr, "    - Ligne ");
         int2str(&(cInt[0]), k+1);
         strcat(err.messageErr, cInt);
         strcat(err.messageErr, " : vous avez entr des lignes de code avant l'en-tte \"ScriptName NOM\" (ou \"Scn NOM\") !");
         fwrite(&err, sizeof(ERREUR), 1, fLog);
         ligneTraitee = 1;
         fclose(fLog);
    }
    
    if ( ( var == 0 ) && ( ligneTraitee == 1 ) && ( BlocBegin[k] == 0 ) ) {
         fLog = fopen("DbTempTES4", "ab");
         if ( fLog == NULL ) {
              printf("Impossible d'ouvrir le fichier temporaire \"DbTempTES4\" depuis le fichier source \"MainSyntaxe.cpp\"\n\n", ScNom);
              system("PAUSE");
              exit(1);
         }
         err.ligneErr = k;
         err.niveau = 2;
         strcpy(err.messageErr, "    - Ligne ");
         int2str(&(cInt[0]), k+1);
         strcat(err.messageErr, cInt);
         strcat(err.messageErr, " : vous avez entr des lignes de code hors d'un bloc Begin/End !");
         fwrite(&err, sizeof(ERREUR), 1, fLog);
         ligneTraitee = 1;
         fclose(fLog);
    }
    
    if ( ligneTraitee == 0 ) {
         fLog = fopen("DbTempTES4", "ab");
         if ( fLog == NULL ) {
              printf("Impossible d'ouvrir le fichier temporaire \"DbTempTES4\" depuis le fichier source \"MainSyntaxe.cpp\"\n\n", ScNom);
              system("PAUSE");
              exit(1);
         }
         err.ligneErr = k;
         err.niveau = 2;
         strcpy(err.messageErr, "    - Ligne ");
         int2str(&(cInt[0]), k+1);
         strcat(err.messageErr, cInt);
         strcat(err.messageErr, " : impossible de dtecter la syntaxe !");
         fwrite(&err, sizeof(ERREUR), 1, fLog);
         ligneTraitee = 1;
         fclose(fLog);
    }
}

fclose(fScript);

}
